<?PHP

// GoDaddy API Credentials
$API_SECRET = 'Your secret';
$API_KEY = 'Your key';

// The domain name you would like to purchase
$domain = "alvinbrownie.xyz";

// The value for agreement keys found in $bodyContent variable - further down page
$dnra = "DNRA";

// Whether or not to auto renew: true or false
$autoRenew = 'true';

// Period of years 1-10, default value: 2
$period = 2;

// Whether or not to include privacy in purchase: true or false
$privacy = 'false';

// Agreed to datetime of purchase
$agreeAtTime = "2019-11-22T18:50:13Z";

// IP address from wich purchase is being made
$agreedByIP = "123.123.123.123";

// Nameservers to point domain too
$nameserver_one = "ns50.domaincontrol.com";
$nameserver_two = "ns60.domaincontrol.com";


// address information for domain
$addressOne = "12345 Test Blvd";
$addressTwo = " ";
$city = "Austin";
$country = "US";
$postalCode = "78910";
$state = "Texas"

// contact information for domain
$email = "info@dnstrategies.com";
$fax = "+1.5121234567";
$jobTitle = "Owner";
$nameFirst = "Joe";
$nameLast = "Doe";
$nameMiddle = "B";
$organization = "JBD Strategies, LLC"
$phone = "+1.5121234567";




$bodyContent = '
{
  "consent": {
    "agreedAt": "'.$agreeAtTime.'",
    "agreedBy": "'.$agreedByIP.'",
    "agreementKeys": [
      "'.$dnra.'"
    ]
  },
  "contactAdmin": {
      "address1": "'.$addressOne.'",
      "address2": "'.$addressTwo.'",
      "city": "'.$city.'",
      "country": "'.$country.'",
      "postalCode": "'.$postalCode.'",
      "state": "'.$state.'"
    },
    "email": "'.$email.'",
    "fax": "'.$fax.'",
    "jobTitle": "'.$jobTitle.'",
    "nameFirst": "'.$nameFirst.',
    "nameLast": "'.$nameLast.'",
    "nameMiddle": "'.$nameMiddle.'",
    "organization": "'.$organization.'",
    "phone": "'.$phone.'"
  },
  "contactBilling": {
    "addressMailing": {
      "address1": "'.$addressOne.'",
      "address2": "'.$addressTwo.'",
      "city": "'.$city.'",
      "country": "'.$country.'",
      "postalCode": "'.$postalCode.'",
      "state": "'.$state.'"
    },
    "email": "'.$email.'",
    "fax": "'.$fax.'",
    "jobTitle": "'.$jobTitle.'",
    "nameFirst": "'.$nameFirst.',
    "nameLast": "'.$nameLast.'",
    "nameMiddle": "'.$nameMiddle.'",
    "organization": "'.$organization.'",
    "phone": "'.$phone.'"
  },
  "contactRegistrant": {
    "addressMailing": {
      "address1": "'.$addressOne.'",
      "address2": "'.$addressTwo.'",
      "city": "'.$city.'",
      "country": "'.$country.'",
      "postalCode": "'.$postalCode.'",
      "state": "'.$state.'"
    },
    "email": "'.$email.'",
    "fax": "'.$fax.'",
    "jobTitle": "'.$jobTitle.'",
    "nameFirst": "'.$nameFirst.',
    "nameLast": "'.$nameLast.'",
    "nameMiddle": "'.$nameMiddle.'",
    "organization": "'.$organization.'",
    "phone": "'.$phone.'"
  },
  "contactTech": {
    "addressMailing": {
      "address1": "'.$addressOne.'",
      "address2": "'.$addressTwo.'",
      "city": "'.$city.'",
      "country": "'.$country.'",
      "postalCode": "'.$postalCode.'",
      "state": "'.$state.'"
    },
    "email": "'.$email.'",
    "fax": "'.$fax.'",
    "jobTitle": "'.$jobTitle.'",
    "nameFirst": "'.$nameFirst.',
    "nameLast": "'.$nameLast.'",
    "nameMiddle": "'.$nameMiddle.'",
    "organization": "'.$organization.'",
    "phone": "'.$phone.'"
  },
  "domain": "'.$domain.'",
  "nameServers": [
    "'.$nameserver_one.'","'.$nameserver_two.'"
  ],
  "period": '.$period.',
  "privacy": '.$privacy.',
  "renewAuto": '.$autoRenew.'
}';





    // url for GoDaddy API
    $url = "https://api.godaddy.com/v1/domains/purchase";

    //echo $url;
    //die();

    // set your key and secret
    $header = array(
            "Authorization: sso-key $API_KEY:$API_SECRET",
            'Content-Type: application/json',
            'Accept: application/json'
    );

    //open connection
    $ch = curl_init();
    $timeout=60;

    //set the url and other options for curl
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout);
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER,false);  
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'POST'); // Values: GET, POST, PUT, DELETE, PATCH, UPDATE 
    curl_setopt($ch, CURLOPT_POSTFIELDS, $bodyContent);
    //curl_setopt($ch, CURLOPT_POST, true);
    curl_setopt($ch, CURLOPT_HTTPHEADER, $header);

    //execute call and return response data.
    $result = curl_exec($ch);

    //close curl connection
    curl_close($ch);

    // decode the json response
    $dn = json_decode($result, true);


    $errmsg = '';

    // check if error code
    if(isset($dn['code'])){

      $errmsg = explode(":",$dn['message']);

      $errmsg = '<h2 style="text-align:center;">'.$errmsg[0].'</h2>';
    
    } else {

      $errmsg = 'Domain purchased.';

    }

echo $errmsg;

?>